<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Commanders: Main Page</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Commanders
   </div>
   <div id="projectbrief">Arduino buttons/bus library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('index.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">Commanders Documentation</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>A full explanation in french can be read at <a href="http://www.locoduino.org/spip.php?article165">http://www.locoduino.org/spip.php?article165</a> .</p>
<p>The goal of this library is to virtualize input through a lot of ways (hardware buttons, bus, radio and so on) in order to be able to drive the rest of the sketch without taking care of the way the information was got.</p>
<p>Passing this information from the commanders through the accessories is done by events of type COMMANDERS_TYPE_EVENT. Each event have an Id, a type (MOVE, TOGGLE, MOVEPOSITION, LEFT, RIGHT, TOP, BOTTOM, etc... An additional integer is added with some events to complete the event information : the position value for MOVEPOSITION for instance.</p>
<p>Each kind of <a class="el" href="classCommanders.html">Commanders</a> can be excluded from compilation, for memory problems purpose or for naming conflicts. Inside some <a class="el" href="classCommanders.html">Commanders</a>, sub items can be excluded too, like the different buttons in the ButtonsCommander. You can exclude some parts of library here, to avoid losing program and data memory on parts you dont use. For example, if you dont want DCC, just uncomment the line #define NO_DCCCOMMANDER by removing // at the beggining.</p>
<p>CANCommander is excluded by default, because this is a rare usage of the library, and the associated CAN libray mcp_can consume memory for nothing if this commander is not used.</p>
<p>The Arduino IDE compiles all the files of the library 'src' directory even if its content is not used. The result is, if an unused source file contains static declarations (SERIAL, DCC or CAN do !), these statics will be allocated and this memory will be lost. The only solution I have found is to rename the source files to something IDE dont know... So if you want to lose less memory, you can rename the linked files from .cpp to .ori, and from .hpp to .hppori. See below in the exclusion area the file names related to each exclusion. </p>
</div></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on mer. oct. 18 2017 17:55:02 for Commanders &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
